/****
 *
 * Exemplo: Demontra o uso de recurso e pilha de execuo
 *
 * Seo: 1.4.2
 *
 * Descrio: Calcula recursivamente a soma dos valores de 1
 *            at um certo valor inteiro positivo
 *
 ****/

#include <stdio.h> /* printf() */

/****
 *
 * SomaAteN(): Calcula recursivamente a soma dos valores
 *             compreendidos entre 1 e o valor recebido
 *             como parmetro
 *
 * Parmetros:
 *      n (entrada) - valor cuja soma at ele ser calculada
 *
 * Retorno: A soma dos valores compreendidos entre 1 e o parmetro
 *
 * Observaes: Este  um mero exerccio DIDTICO. No imite esta
 *              funo na prtica.
 *
 ****/
int SomaAteN(int n)
{
   int s;

   if (n <= 0)
      return 0; /* Erro de domnio */

   if (n <= 1)
      return n; /* Condio de parada */

      /* Caso recursivo */
   s = n + SomaAteN(n - 1); /* endereo e2 */

   return s;
}

/****
 *
 * main(): Testa a funo SomaAteN()
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main(void)
{
   int soma;

   soma = SomaAteN(3); /* endereo e1 */

   printf("\n>> Soma de 1 ate' 3: %d\n", soma);

   return 0;
}

/****************** Resultado do Programa *****************


**********************************************************/
