/****
 *
 * Exemplo: ArMulti.c
 *
 * Seo: 2.7.5
 *
 * Demonstra: Relao entre Ponteiros e Arrays Multidimensionais
 *
 ****/

#include <stdio.h>

#define IMP(x) printf("\n%s = %d", #x, x)
#define IMP_END(x) printf("\n%s = %p", #x, x)

void F(int array[][3][2])
{
   IMP_END(array);
}

int main(void)
{
   int arA[2][3][2] = { { {1, 2}, {0, 0}, {1, 1} },
                        { {0, 1}, {1, 0}, {0, 0} } };

//   int  arB[][] = { 1, 2, 3, 4, 5, 6};    /* ILEGAL */

   int ar1[2][3][4];
   int x;
   int ar[2][3] = { {1, 2, 3},
                    {4, 5, 6} };
   int tamInt = sizeof(int);

   x = ar1[1][1][2];
//   ar[1,2] = 0;   /* ILEGAL */

   x = ar[1][2];

   IMP(tamInt);
   IMP(ar[1][2]);
   IMP(*(ar[1]+2));
   IMP(*(*(ar + 1) + 2));
   IMP(*(int *)( ( (char *)ar + (1*3*4) ) + (2*4) ));
   IMP(*(int *)( (char *)ar + 20 ));
   IMP_END(ar[1]);
   IMP_END(&ar[1][0]);
   IMP_END(&arA);
   F(arA);

   return 0;
}

/****************** Resultado do Programa *****************

Resultado do programa:

tamInt = 4
ar[1][2] = 6
*(ar[1]+2) = 6
*(*(ar + 1) + 2) = 6
*(int *)( ( (char *)ar + (1*3*4) ) + (2*4) ) = 6
*(int *)( (char *)ar + 20 ) = 6
ar[1] = 0064FD60
&ar[1][0] = 0064FD60
&arA = 0064FDCC
array = 0064FDCC

**********************************************************/
