/****
 *
 * Ttulo: Implementao de Pilhas Usando Arrays Dinmicos
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/04/2014
 * ltima modificao: 16/04/2014
 *
 * Descrio: Testa uma implementao de pilhas usando arrays
 *            dinmicos
 *
 * Entrada: No h
 *
 * Sada: V. resultado do programa
 *
 ****/

#include <stdio.h>  /* Funes de Entrada/Sada  */
#include "Pilha.h"  /* Declaraes do tipo pilha */
                    /* implementada com array    */

/****
 *
 * main(): Testa as operaes sobre pilhas. O resultado deve
 *         ser o mesmo, quer utilizem-se pilhas alocadas com
 *         array, quer utilizem-se pilhas alocadas dinamicamente
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main (void)
{
   tPilha *pilha;
   char    c;

   CriaPilha(&pilha);  /* Inicializa a pilha */

   c = 'a';
   Empilha(pilha, (tElemento *) &c);  /* Empilha 'a' */

   c = 'b';
   Empilha(pilha, (tElemento *) &c);  /* Empilha 'b' */

   c = 'c';
   Empilha(pilha, (tElemento *) &c);  /* Empilha 'c' */

      /* Exibe na tela o elemento no topo */
      /* da pilha sem desempilh-lo       */
   printf("\nElemento no topo: %c", ElementoTopo(pilha));

      /* Desempilha e imprime sucessivamente */
      /* os elementos no topo da pilha       */
   printf("\nDesempilhado: %c", Desempilha(pilha));
   printf("\nDesempilhado: %c", Desempilha(pilha));
   printf("\nDesempilhado: %c", Desempilha(pilha));

   return 0;
}

/****************** Resultado do Programa *****************

Elemento no topo: c
Desempilhado: c
Desempilhado: b
Desempilhado: a

 *************************************************************/
