/****
 *
 * Ttulo: Implementao de Filas Usando Arrays Dinmicos
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/06/2012
 * ltima modificao: 16/06/2012
 *
 * Descrio: Testa as operaes sobre filas implementadas
 *            com arrays dinmicos
 *
 * Entrada: No h
 *
 * Sada: Resultados de operaes sobre filas
 *
 ****/

#include <stdio.h> /* Entrada e Sada         */
#include "Fila.h"  /* Definies do tipo fila */

/****
 *
 * main(): Testa as operaes sobre filas implementadas
 *         com arrays dinmicos
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero
 *
 ****/
int main (void)
{
   tFila *fila;
   char   c;

   CriaFila(&fila);  /* Inicializa a fila */

   c = 'a';
   Acrescenta(fila, (tElemento *) &c);  /* Acrescenta 'a' */

   c = 'b';
   Acrescenta(fila, (tElemento *) &c);  /* Acrescenta 'b' */

   c = 'c';
   Acrescenta(fila, (tElemento *) &c);  /* Acrescenta 'c' */

      /* Imprime o elemento na frente da fila sem remov-lo */
   printf("\nElemento na frente: %c", ElementoFrente(fila));

      /* Remove e imprime sucessivamente os elementos na frente da fila */
   printf("\nRetirado: %c", Retira(fila));
   printf("\nRetirado: %c", Retira(fila));
   printf("\nRetirado: %c", Retira(fila));

      /* Agora, a fila est vazia. Se o comentrio da instruo */
      /* a seguir for removida, o progrma ser abortado         */
   /* printf("\nRetirado: %c", Retira(&fila)); */

      /* O lao a seguir serve para testar a funo FilaCheia().  */
      /* Se o corpo desta funo for substitudo simplesmente por */
      /* return f->fundo >= MAX_ELEMENTOS - 1, o programa ser    */
      /* abortado devido a uma falsa indicao de fila cheia.     */
   for (c = 'a'; c <= 'z'; ++c) {
      Acrescenta(fila, (tElemento *) &c);
      printf("\nRetirado: %c", Retira(fila));
   }

   return 0;
}

/************* Resultado da Execuo do Programa *************




**************************************************************/
