#ifndef _Lista_H_
#define _Lista_H_

/***************** Constantes Simblicas ******************/

   /* Nmero mximo de caracteres num item */
#define MAX_ITEM      10
   /* Nmero mximo de elementos numa lista */
#define MAX_ELEMENTOS 20

/****************** Definies de Tipos *******************/

   /* Tipo de cada elemento da lista */
typedef char tElemento[MAX_ITEM];

   /* Tipo que representa as listas */
typedef struct {
           int   nElementos; /* Nmero de elementos na lista */
           tElemento elementos[MAX_ELEMENTOS]; /* Os elementos */
        } tLista;

/******************* Aluses de Funes *******************/

extern void IniciaLista(tLista *lista);
extern int Comprimento(const tLista *lista);
extern char *ObtemElemento(const tLista *lista, int pos);
extern void InsereElemento( tLista *lista, tElemento elemento,
                            int pos );
extern char *RemoveElemento(tLista *lista, int pos);
extern int EstaVazia(const tLista *lista);
extern int BuscaElemento(const tLista *lista, tElemento elemento);
extern void AcrescentaElemento(tLista *lista, tElemento elemento);
extern void AlteraElemento(tLista *lista, tElemento valor, int pos);

extern int EstaCheia(const tLista *lista);

#endif
