/****
 *
 * Ttulo: Fila Encadeada
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 16/06/2012
 * ltima modificao: 16/06/2012
 *
 * Descrio: Testa as operaes sobre filas encadeadas
 *
 * Entrada: No h
 *
 * Sada: Resultados de operaes sobre filas
 *
 ****/

#include <stdio.h> /* Funes de Entrada/Sada           */
#include "Fila.h" /* Declaraes do tipo fila encadeada */

/****
 *
 * main(): Testa as operaes sobre filas
 *
 * Parmetros: Nenhum
 *
 * Retorno: Zero, se no ocorrer nenhum erro.
 *          Um valor diferente de zero em caso contrrio.
 *
 ****/
int main (void)
{
   tFila fila;
   char  c;

   CriaFila(&fila);  /* Inicializa a fila */

   c = 'a';
   Acrescenta(&fila, (tElemento *) &c);  /* Acrescenta 'a' */

   c = 'b';
   Acrescenta(&fila, (tElemento *) &c);  /* Acrescenta 'b' */

   c = 'c';
   Acrescenta(&fila, (tElemento *) &c);  /* Acrescenta 'c' */

      /* Imprime o elemento na frente da fila sem remov-lo */
   printf("\nElemento na frente: %c", ElementoFrente(&fila));

      /* Remove e imprime sucessivamente os elementos na frente da fila */
   printf("\nRetirado: %c", Retira(&fila));
   printf("\nRetirado: %c", Retira(&fila));
   printf("\nRetirado: %c", Retira(&fila));

      /* Agora, a fila est vazia. Se o comentrio da instruo */
      /* a seguir for removida, o progrma ser abortado         */
   /* printf("\nRetirado: %c", Retira(&fila)); */

      /* O lao a seguir serve para testar a funo FilaCheia().  */
      /* Se o corpo desta funo for substitudo simplesmente por */
      /* return f->fundo >= MAX_ELEMENTOS - 1, o programa ser    */
      /* abortado devido a uma falsa indicao de fila cheia.     */
   for (c = 'a'; c <= 'z'; ++c) {
      Acrescenta(&fila, (tElemento *) &c);
      printf("\nRetirado: %c", Retira(&fila));
   }

   return 0;
}

/************* Resultado da Execuo do Programa *************

Elemento na frente: a
Retirado: a
Retirado: b
Retirado: c
Retirado: a
Retirado: b
Retirado: c
Retirado: d
Retirado: e
Retirado: f
Retirado: g
Retirado: h
Retirado: i
Retirado: j
Retirado: k
Retirado: l
Retirado: m
Retirado: n
Retirado: o
Retirado: p
Retirado: q
Retirado: r
Retirado: s
Retirado: t
Retirado: u
Retirado: v
Retirado: w
Retirado: x
Retirado: y
Retirado: z


**************************************************************/
