#ifndef _Lista_H_
#define _Lista_H_

#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tChave[TAM_CEP + 1];

typedef struct {
           tChave chave; /* CEP */
           int    valor; /* ndice do CEP no arquivo */
        } tConteudo;

   /* Tipo de n do nvel 0 */
typedef struct no {
           tConteudo  conteudo; /* Contedo efetivo    */
           struct no **proximo; /* Prximo n da lista */
        } tNo;

   /* Tipo de lista com saltos */
typedef struct {
           tNo *cabeca;   /* Cabea da lista         */
           int  nivel;    /* Nvel corrente da lista */
           int  nivelMax; /* Nvel mximo da lista   */
        } tListaComSaltos;

/************************* Aluses ************************/

extern void ApresentaComprimentosPorNivel(tListaComSaltos lista);
extern void ApresentaRelacoesEntreNiveis(tListaComSaltos lista);
extern void ApresentaNiveis(tListaComSaltos lista);

extern void IniciaListaComSaltos( tListaComSaltos *lista,
                                  int maxRegs );
extern int EstaVaziaListaComSaltos(tListaComSaltos lista);
extern int ComprimentoListaComSalto(tListaComSaltos lista);
extern tConteudo *BuscaListaComSaltos( tListaComSaltos lista,
                                       tChave chave );
extern tNo *InsereNoListaComSaltos( tListaComSaltos *lista,
                                    tConteudo conteudo );
extern int RemoveNoListaComSaltos( tListaComSaltos *lista,
                                  tChave chave );
extern void AlteraConteudoListaComSaltos( tListaComSaltos lista,
                                          tConteudo *antigo,
                                          tConteudo *novo );
extern tConteudo *ProximoListaComSaltos(tListaComSaltos lista);
extern void DestroiListaComSaltos(tListaComSaltos lista);

#endif
