/****
 *
 * Arquivo: Arvore.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo Arvore2
 *
 ****/

#ifndef _Arvore_H_
#define _Arvore_H_

/****************** Definies de Tipos *******************/

typedef char tConteudo;

typedef struct  no {
           struct no *esquerda;
           tConteudo  conteudo;
           struct no *direita;
        } tNo, *tArvore;

typedef void (*tOperacao) (tConteudo);

/************************* Aluses ************************/

extern tArvore ConstroiNo(tConteudo item);
extern void FilhoEsquerda(tNo *pNo, tConteudo item);
extern void FilhoDireita(tNo *pNo, tConteudo item);
extern void Prefixo(tArvore arvore, tOperacao op);
extern void Exibe(tArvore arvore, tOperacao fImpressao);
extern int Profundidade(tArvore p);
extern int SaoSemelhantes( tArvore arvore1,
                           tArvore arvore2 );
extern tArvore CopiaArvore(tArvore arvore);
extern int NivelDoNo(tArvore arvore, tArvore pNo);
extern tArvore ArvoreFib(int n);
extern int NumeroDeNos(tArvore arvore);
extern void DestroiArvoreBin(tArvore arvore);

#endif
