/****
 *
 * Arquivo: ArvoreC.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo ArvoreC (rvore costurada)
 *
 ****/

#ifndef _ArvoreC_H_
#define _ArvoreC_H_

/****************** Definies de Tipos *******************/

typedef  char tConteudo;

typedef enum {SIM, NAO} tCostura;

typedef  struct  no {
            struct  no *esquerda;
            tConteudo   conteudo;
            struct  no *direita;
            tCostura    costura;
         } tNoC, *tArvoreC;

/************************* Aluses ************************/

typedef void (*tOperacao) (tConteudo);

extern tArvoreC ConstroiNoC(tConteudo item);
extern void FilhoEsquerdaC(tNoC *pNo, tConteudo item);
extern void FilhoDireitaC(tNoC *pNo, tConteudo item);
extern void InordemC(tArvoreC arvore, tOperacao op);
extern void PreordemC(tArvoreC arvore, tOperacao op);
extern void PosordemC(tArvoreC arvore, tOperacao op);
extern void ExibeC(tArvoreC arvore, tOperacao fImpressao);

#endif
