/****
 *
 * Arquivo ArvoreBB.h
 *
 * Autor: Ulysses de Oliveira
 *
 * Data de Criao: 22/07/2012
 * ltima modificao: 22/07/2012
 *
 * Descrio: Interface do mdulo ArvoreBB
 *
 ****/

#ifndef _ArvoreBB_
#define _ArvoreBB_

#include <stdio.h>     /* FILE */
#include "Registros.h" /* Interface do mdulo Registros */

/****************** Definies de Tipos *******************/

   /* Tipo de chave */
typedef char tChave[TAM_CEP + 1];

   /* Tipo do contedo de cada n */
typedef struct {
           tChave chave; /* CEP */
           int    valor; /* ndice do CEP no arquivo */
        } tConteudo;

   /* Tipo de n e tipo de ponteiro  */
   /* para n de uma rvore binria  */
typedef struct no {
           struct no *esquerda;
           tConteudo  conteudo;
           struct no *direita;
        } tNo, *tArvoreBB;

typedef void (*tOperacao) (tConteudo, FILE*);

/************************* Aluses ************************/

extern void IniciaArvoreBB(tArvoreBB *arvore);
extern int NumeroNosArvoreBB(tArvoreBB arvore);
extern int ProfundidadeArvoreBB(tArvoreBB arvore);
extern tConteudo *BuscaArvoreBB(tArvoreBB arvore, tChave chave);
extern int InsereNoArvoreBB( tArvoreBB *arvore,
                             const tConteudo *conteudo );
extern int RemoveNoArvoreBB(tArvoreBB *arvore, tChave chave);
extern int EstaVaziaLSE(tArvoreBB arvore);
extern int AlteraConteudoArvoreBB( tArvoreBB *arvore,
                                   tChave chave,
                                   const tConteudo *conteudos );
extern void DestroiArvoreBin(tArvoreBB arvore);
extern void CaminhamentoInfixo( tArvoreBB arvore, tOperacao op,
                                FILE *stream );
extern tConteudo *MenorChave(tArvoreBB p);
extern tConteudo *MaiorChave(tArvoreBB p);

#endif
